function [emd, gamma] = ot(p, q, C)

m = length(p);
n = length(q);
C = C(:);

lb  = zeros(m * n,1); 
ub  = [];
A   = [];
B   = [];
beq = cat(1, p, q);

A1 = repmat(speye(m), 1, n);
A2 = sparse(n, m * n);
for i = 1: n
    A2(i, (i - 1) * m + 1: i * m) = ones(1, m);
end
Aeq = cat(1, A1, A2);
clear A1 A2

options         = optimset;
[gamma, emd]    = linprog(C, A, B, Aeq, beq, lb, ub, [], options);
gamma           = reshape(gamma, m, n);